﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using PokktXamarinSDK;
using Android.Util;

namespace PokktSample
{
	[Activity (Label = "OfferwallActivity")]			
	public class OfferwallActivity : Activity, IOfferwallDelegate
	{
		string TAG = "PokktXamarinSample";

		private EditText edt_points;
		private CheckBox chbox_close_success;

		protected override void OnCreate (Bundle bundle)
		{
			RequestWindowFeature (WindowFeatures.NoTitle);
			base.OnCreate (bundle);

			// Create your application here
			SetContentView(Resource.Layout.Offerwall);

			PokktManagerHandler.OfferwallDelegate = this;
			PokktManagerHandler.SetDebug(true);
			//Mendatory to do this
			PokktManagerHandler.SetActivity(this);
			PokktManagerHandler.SetApplicaionId ("a2717a45b835b5e9f50284a38d62a74e");
			PokktManagerHandler.SetSecurityKey ("iJ02lJss0M");
			PokktManagerHandler.SetIntegrationType (0);
			PokktManagerHandler.SetAutoCacheVideo (false);
			testOpetionalMethods ();
			PokktManagerHandler.InitPokkt ();

			chbox_close_success = (CheckBox) FindViewById(Resource.Id.chk_close_on_success);
			chbox_close_success.SetOnCheckedChangeListener(new CheckedChangeListener());

			edt_points = (EditText) FindViewById(Resource.Id.edt_max_points);
			edt_points.SetTextColor (Android.Graphics.Color.Black);
			edt_points.SetOnClickListener(new EditTextClickAction(this));

			Button btnCoins = FindViewById<Button> (Resource.Id.get_coins);
			btnCoins.Click += delegate 
			{
				PokktManagerHandler.GetCoins();
			};

			Button btnGetFixedCoins = FindViewById<Button> (Resource.Id.get_fixed_coins);
			btnGetFixedCoins.Click += delegate 
			{
				String temp = edt_points.Text;
				try {
					if (!"".Equals(temp)) {
						PokktManagerHandler.SetOfferWallAssetValue(edt_points.Text);
						PokktManagerHandler.GetCoins();
					}
					else{
						Toast.MakeText(this, "Please enter points", ToastLength.Short).Show();
					}
				}
				catch(Exception e) {
					Log.Debug(TAG, e.Message);
					Toast.MakeText(this, "Please enter valid points", ToastLength.Short).Show();
				}
					
			};

			Button btnPendingCoins = FindViewById<Button> (Resource.Id.pending_coins);
			btnPendingCoins.Click += delegate 
			{
				PokktManagerHandler.GetPendingCoins();
			};
		}

		class EditTextClickAction : Java.Lang.Object, Android.Views.View.IOnClickListener
		{   
			public EditTextClickAction(Context Context)
			{
			}
			public void OnClick (View v)
			{
				EditText editText = (EditText)v;
				editText.Focusable = true;
				editText.FocusableInTouchMode = true;
			}
		}

		private class CheckedChangeListener : Java.Lang.Object, CompoundButton.IOnCheckedChangeListener
	    {
	        public CheckedChangeListener()
	        {
	        }
	 
	        public void OnCheckedChanged(CompoundButton buttonView, bool isChecked)
	        {
	            if (isChecked)
	            {
					PokktManagerHandler.SetCloseOnSuccessFlag (isChecked);
				}
	        }
	     }

		void testOpetionalMethods()
		{
			PokktManagerHandler.SetDefaultSkipTime (5);
			PokktManagerHandler.SetSkipEnabled (true);
			PokktManagerHandler.SetThirdPartyUserId ("1234");
			PokktManagerHandler.SetBackButtonDisabled (false);
			PokktManagerHandler.SetCustomSkipMessage ("Are you sure?");
			PokktManagerHandler.SetCloseOnSuccessFlag (true);

			PokktManagerHandler.SetAge ("32");
			PokktManagerHandler.SetBirthday ("20/08/1983");
			PokktManagerHandler.SetEducation ("MCA");
			PokktManagerHandler.SetEmailAddress ("pankaj454k@gmail.com");
			PokktManagerHandler.SetEmployment ("SE");
			PokktManagerHandler.SetFacebookId ("pankaj454k");
			PokktManagerHandler.SetLocation ("Bangalore");
			PokktManagerHandler.SetMaritalStatus ("Married");
			PokktManagerHandler.SetMaturityRating ("for all");
			PokktManagerHandler.SetMobileNo ("9900064040");
			PokktManagerHandler.SetName ("Pankaj");
			PokktManagerHandler.SetNationality ("Indian");
			PokktManagerHandler.SetSex ("Male");
			PokktManagerHandler.SetTwitterHandle ("pankaj454k");
		}

		void updateUI(int points, string trans_id = "") {
			if (trans_id.Length > 0) {
				((TextView)FindViewById (Resource.Id.points)).Text = "Points earned: " + points;
			}
			else {
				((TextView)FindViewById (Resource.Id.points)).Text = "Points earned: " + points + " and transaction ID:" + trans_id;
			}
		}

		protected override void OnResume()
		{
			Task.Factory.StartNew(() => 
				{
					PokktManagerHandler.CheckOfferWallCampaign();
					PokktManagerHandler.GetPendingCoins();
				});
			
			base.OnResume ();
		}

		void IOfferwallDelegate.CoinResponseFailed(string message)
		{
			Log.Debug (TAG, message);
		}

		void IOfferwallDelegate.EarnedCoins(int coins)
		{
			Log.Debug (TAG, coins.ToString());
			updateUI (coins);
		}

		void IOfferwallDelegate.EarnedCoins(int coins, string transaction_id)
		{
			Log.Debug (TAG, coins.ToString(), transaction_id);
			updateUI (coins);
		}

		void IOfferwallDelegate.OnOfferwallCampaignCheck(bool status)
		{
			Log.Debug (TAG, status.ToString());
		}

		void IOfferwallDelegate.OnOfferwallClosed()
		{
			Log.Debug (TAG, "on offerwall closed");
		}
	}
}

